#include "GenericTypeDefs.h"
#include "Compiler.h"
#include "HardwareProfile.h"
#include "EEP.h"
#include "delays.h"
#include "usb_config.h"

#include "eusart.h"

#define _userap_kp
#include "userap.h"

#define uint8_t   uchar 
#define int8_t   char 
#define uint16_t  unsigned int 
#define int16_t   int 

uint8_t cx(uint8_t d1);
void   hex2( uint16_t d );
void   hex1( uint8_t d );
//void   itoa( int dd, uint8_t l );
void ProcessIO(void);
void eepinit();
  
#pragma	code

void res_str( auto const rom char *m)
{  char d;
	while(*m!=0){
	d=*m;

	setres(d);
	m++;}
}

//void   itoa( int dd, uint8_t l )
void   xitoa( int dd, uchar l )
{	
	int8_t u, ov;
	
	if(dd==0x8000 && l>5){
		res_str("-32768");
	} else {
		if(dd<0){dd=-dd;setres('-');l--;}

	    ov=0;
		if(        l<5 && dd>9999 ){ov=1;res_str("****");
		} else if( l<4 && dd> 999 ){ov=1;res_str("***");
		} else if( l<3 && dd>  99 ){ov=1;res_str("**");
		} else if( l<2 && dd>   9 ){ov=1;res_str("*");
		} else if( l==0          ){ov=1;}
		if( ov==0){
			if(l>4){u=0;while( dd-10000>0){u++;dd=dd-10000;}
			setres('0'+u);}
			
			if(l>3){u=0;while( dd-1000>0) {u++;dd=dd-1000;}
			setres('0'+u);}
			
			if(l>2){u=0;while( dd-100>0)  {u++;dd=dd-100;}
			setres('0'+u);}
			
			if(l>1){u=0;while( dd-10>0)   {u++;dd=dd-10;}
			setres('0'+u);}
			
			u=0;while( dd-1>=0)   {u++;dd=dd-1;}
			setres('0'+u);
		}
	}
}
void pccntl(void)
{
	unsigned char c1, c2;
	
	if(T2CONbits.TMR2ON==0){
		c2=TMR0L;
		c1=TMR0H;
		if(c1 > 140 ){
			TMR0H=0;
			TMR0L=0;
			pcc1++;
			if(pcc1>9){
				pcc1=0;
				PORTC &= 0xfd;         //  POWER off
			}
			
		}
	}
}

void userinit(void){
	uchar rw;	
	int ii;
	
	TRISC &= 0x04;
	TRISB &= 0x0F;
	PORTC =  0;
	PORTB =  0;
	
	RCONbits.IPEN = 1; 			// 荞݃vCIeB(Low,High)Cl[u
	INTCONbits.GIEL = 1; 		// Low  Priority 荞݂.
	INTCONbits.GIEH = 1; 		// High Priority 荞݂.
//             ****
//	T2CON = 0b00000111 ;    // 1:1
//	T2CON = 0b01111111 ;    // 1:16
//	T2CON = 0b00011111 ;    // 1:4
	T2CON = 0b00001111 ;    // 1:2
//	T2CON = 0b00000111 ;    // 1:1

	
	T0CON = 0b10000111 ;    // 1:256
	TMR0H=0;
	TMR0L=0;

    PR2=8;       // WJEg߂Ŋݔ   Xs[h@@@1002.4ms
    TMR2 = 0 ;
    PIR1bits.TMR2IF = 0 ;
	PIE1bits.TMR2IE = 1 ;
	
	INTCONbits.PEIE = 1 ;    //@@@@@@// ӑu荞ݗL
	INTCONbits.GIE  = 1 ;     //@@@	
	icnt=0;
		
	res_w=0;
	res_r=0;
	res_ovf=0;
	cmd_w=0;
	cmd_r=0;
	cmd_ovf=0;
    MK  =		Read_b_eep (0x0002);         //  [^[ށ@1: oC|[@QFj|[
    sou =		Read_b_eep (0x000E);         //  1: 1,@2:2A@3 : P|Q Ver2.2 Ȍx@Xs[h
	if( sou==0xFF |  MK==0xFF ){
	    eepinit();    //  oC|[@1-2@ŏ
	    MK  = Read_b_eep (0x0002);         //  [^[ށ@1: oC|[@QFj|[
	    sou = Read_b_eep (0x000E);         //  1: 1,@2:2A@3 : P|Q Ver2.2 Ȍx@Xs[h
	}
	if( sou != 1 & sou!=2 & sou!=3 ){
	    Write_b_eep(0x000E,3);     				 // 1-2 
	    sou = Read_b_eep (0x000E);         
	}
	if(  MK!=1 & MK!=2 ){
	    Write_b_eep(0x0002,1);   			    // oC|[
		MK  = Read_b_eep (0x0002);          
	}
	er_bp2=0;
	if(MK==1 & sou==2) er_bp2=1;
	
    spx =		Read_b_eep (0x0006);         //  x Xs[h
    spy =		Read_b_eep (0x0007);         //  y Xs[h
    accn     =  Read_b_eep (0x000B);         //  e[uL@@@0:Ȃ
    xf       =  Read_b_eep (0x000C) - 128;   //  e[u  x ItZbg
    brakes_f =  Read_b_eep (0x000D);         //  u[LtO
    PR2      =  Read_b_eep (0x0021);         //  ]x
	if( PR2 == 0 ) PR2 = 8;
	
	 er_acdt = 0;
    for(ii=0;ii<accn;ii++){
             acce[ii]    = Read_b_eep (0x0010+ii)  ;   // f[^
    	if( acce[ii] ==0 ) 	    er_acdt=1;
    	if( acce[ii]-xf <0 ) 	er_acdt=1;
    	
    }
	if( er_acdt == 1 ) accn=0;
	er_sp=0;
	if( spx == 0 | spy==0 ) er_sp=1;

	if( sou == 3 ) smax=7;
	else           smax=3;
	xkeep=0;
	ykeep=0;
    wait=CMD_GO;  // R}h~    1/0    wait/go
	T2CONbits.TMR2ON=0;  //  ^C}[~
	Delay1KTCYx(0);        //  21m sec
	PORTC |= 0x02;         //  POWER CNTL
	pcc1=0;
	okflg=1;
}	

void setres(char c)
{
	uchar wp;
	wp=res_w+1;
	if(wp== res_max)wp=0;
	if(wp!=res_r){   
		res_w++;if(res_w == res_max)res_w=0;
		RES_Buf[res_w]=c;
	} else {
	  res_ovf=1;    // t
	}
}
	
char getres(){
	char c;	
	if(idling) return 0;
	if(res_w != res_r){
		res_r++;if(res_r == res_max)res_r=0;
		c = RES_Buf[res_r];
		return c;		
	} else {
		return 0;	
	}
}
	
void setcmd(char c)
{
	uchar wp;
	if(idling) return;
	wp=cmd_w+1;
	if(wp== cmd_max)wp=0;
	if(wp!=cmd_r){   
		cmd_w++;if(cmd_w == cmd_max)cmd_w=0;
		CMD_Buf[cmd_w]=c;
	} else {
		cmd_ovf=1;    // t
	}
	}
	
char getcmd(){
	char c;	
	if(cmd_w != cmd_r){
		cmd_r++;if(cmd_r == cmd_max)cmd_r=0;
		c = CMD_Buf[cmd_r];
		return c;		
	} else {
		return 0;	
	}
}

void ok_msg(char c){
	setres(c);
	if( okflg ) {
		setres('_');
		setres('O');
		setres('K');
	}
}
void ng_msg(char c){
	setres(c);
	setres('_');
	setres('N');
	setres('G');
}

void eepinit(void){       // oC|[@P|Q
	uchar t;
  	Write_b_eep (0x0000,0);   // dummy
  	Write_b_eep (0x0001,0);   // dummy
  	Write_b_eep (0x0002,1);   // BP
  	Write_b_eep (0x0003,0);
  	Write_b_eep (0x0004,0);
  	Write_b_eep (0x0005,0);   
  	Write_b_eep (0x0006,120);   // x spped
  	Write_b_eep (0x0007,120);   // y spped
  	Write_b_eep (0x0008,0);
  	Write_b_eep (0x0009,0);
  	Write_b_eep (0x000A,0);
  	Write_b_eep (0x000B,0);   //e[ũf[^t
  	Write_b_eep (0x000C,128);   // otfset
  	Write_b_eep (0x000D,0);
  	Write_b_eep (0x000E,3);   //  1-2
  	Write_b_eep (0x000F,0);
  	Write_b_eep (0x0010,0);   // acc1
  	Write_b_eep (0x0011,0);
  	Write_b_eep (0x0012,0);
  	Write_b_eep (0x0013,0);
  	Write_b_eep (0x0014,0);
  	Write_b_eep (0x0015,0);
  	Write_b_eep (0x0016,0);
  	Write_b_eep (0x0017,0);
  	Write_b_eep (0x0018,0);
  	Write_b_eep (0x0019,0);
  	Write_b_eep (0x001A,0);
  	Write_b_eep (0x001B,0);
  	Write_b_eep (0x001C,0);
  	Write_b_eep (0x001D,0);
  	Write_b_eep (0x001E,0);
  	Write_b_eep (0x001F,0);
  	Write_b_eep (0x0020,0);  // 
  	Write_b_eep (0x0021,8);  // ]x
  	Write_b_eep (0x0022,0);  // 
}

int errchk(void){
	uchar er;
	er=0;
	if( er_bp2 > 0 ){
		res_str("M@");
		er=1;
	}
	if( er_acdt > 0 ){
		res_str("A@");
		er=1;
	}
	if( er_sp > 0 ){
		res_str("V@");
		er=1;
	}
	if( cmd_ovf > 0 ){
		res_str("O@");
		er=1;cmd_ovf=0;
	}
	if( res_ovf > 0 ){
		res_str("R@");
		er=1;res_ovf=0;
	}
	return er;
}		

void apexec(void)
{
	rom char *sss="gogo rom c18";
	char c;                         /*   ̓R}h                        */
	char c1, c2;                        
	uchar t;
	unsigned int j;                         /*   ̓R}h                        */
    int k;                         /*   ̓R}h                        */
	uchar l;                         /*   ̓R}h                        */
                       /*   ̓R}h                        */

	if(cmd_r != cmd_w) {
		if( wait == CMD_GO){ 
			
			c=getcmd();
	
			  if((c>='0') && (c<='9'))
			  {
				    num_buf=num_buf*10+(long)(c-'0'); 
			  	    step= num_buf;
				    ok_msg(c);
			  } else {
				  switch(c)
				  {
				  case 'C': num_buf=0; /*Num Clear*/
				  	ok_msg('C');
				  	break;
				  	
				  case 'L': 
                    spx=num_buf;
				  	Write_b_eep (0x0006,spx);
				    ok_msg(c);
				  	break;	
				  	
				  case 'l': 
                    spy=num_buf;
				  	Write_b_eep (0x0007,spy);
				    ok_msg(c);
				  	break;	
				  					  	
				  case 'F':
				  	dir=FWD;
				    ok_msg(c);
				  	break;	

				  case 'R':
				  	dir=REV;
				    ok_msg(c);
				  	break;	

				  case 'P':    //==== ]x===== 
				  	if(num_buf>0) {
					  	PR2=num_buf;
					    ok_msg(c);
				  	}
				  	break;	
				  	
				  case 'S':     // 
					T2CON = 0b01111011 ;    // 1:16		
				    ok_msg(c);
				  	break;	

				  case 'X': 
//				  		setres('/'); hex1(cmd_r);             ProcessIO();
//						setres('/'); hex1(cmd_w);setres('/'); ProcessIO();
				  	if( errchk() == 0 ){
						wait = CMD_WAIT;     //  EXEC@x~	
					  	move=MX;
					  	rseq=xkeep;
						cstep=step+2; 
					  	tstep=step;
					  	spw=spx;
					  	PORTC |= 0x02;  Delay1KTCYx(0);      //  POWER CNTL  21m sec   
						T2CONbits.TMR2ON=1;  //  ^C}[X^[g
	//					hex2(tstep);hex2(cstep);ProcessIO();hex1(spw);
					  	stepm();
				  	}
				  	break;
				  	
				  case 'Y': 
				  	if( errchk() == 0 ){
						wait = CMD_WAIT;     //  EXEC@x~
					  	move=MY;
					  	rseq=ykeep;
					  	spw=spy;
					  	PORTC |= 0x02;  Delay1KTCYx(0);      //  POWER CNTL  21m sec   
					  	T2CONbits.TMR2ON=1;  //  ^C}[X^[g
					  	tstep=step;
						cstep=step+2;  
	//				  	hex2(tstep);hex2(cstep);ProcessIO();hex1(spw);
					  	stepm();
				  	}
				  	break;
				  	
				  case 'A': eppad=num_buf; /* epprom address set   */
				  	ok_msg('A');
				  	break;
				  	
				  case 'E': eppdt=num_buf; /* update  epprom      */
				  	if( eppad == 0x000E  &  (eppdt!= 1 & eppdt!=2 & eppdt!=3 ) ){
				  		res_str("S@");break;
					}
				  	if( eppad == 0x000E  &  eppdt==2 & Read_b_eep (2)==1 ){   // oC|[Q@ng
				  		res_str("1@");break;
				  	}				  	
					if( eppad == 0x0002 & ( eppdt!=1 & eppdt!=2 ) ){
				  		res_str("K@");break;
					}
				  	if( eppad == 0x0002  &  eppdt==1 & Read_b_eep (14)==2 ){   // oC|[Q@ng
				  		res_str("1@");break;
				  	}	
				  	if( eppad == 0x0021  &  eppdt==0 ){   // ]x 0́As
				  		res_str("T@");break;
				  	}	
					Write_b_eep(eppad,eppdt);
					eppad++;           /* epprom address incr */
				  	ok_msg('E');
				  	break;
				  	
				  case 'r':              /* read   epprom      */
				    eppdt=Read_b_eep(eppad);
				  	hex1(eppdt); setres('_'); ok_msg('r');
					eppad++;               /* epprom address incr */
				  	break;
				  	
				  case 'V': eppad=num_buf; /* epprom address set   */
				  	res_str("V2.3p1_");
				  	ok_msg('V');
				  	break;
			  	
				  case 'Q':
				  	if(  MK==1 ) {
				  		res_str("/BP/");
				  	} else if (  MK==2 ) {
				  		res_str("/UP/");
				  	} else {
				  		res_str("/--/");	
				  	}
				  	
				  	if(  sou==1 ) {
 				  		res_str("1/");
				  	} else if ( sou==2 ) {
				  		res_str("2/");
				  	} else if( sou==3 ){
		        		res_str("1-2/");	
				  	} else {
				  		res_str("--/");	
				  	}
				  	ok_msg('Q');
				  	break;
 
				  case 'u': 
				  	res_str("\r\n");
				  	res_str("EEPROM\r\n");
				  	for (k=0;k<16;k++) {t=Read_b_eep (k); hex1(t);setres('/');ProcessIO();}res_str("\r\n");
				  	for (k=16;k<32;k++){t=Read_b_eep (k); hex1(t);setres('/');ProcessIO();}res_str("\r\n");		
				  	for (k=32;k<48;k++){t=Read_b_eep (k); hex1(t);setres('/');ProcessIO();}res_str("\r\n");		
				  	break;	
				  	
				  case 'K':     //  _ok }~
				  	if(okflg)  okflg = 0;
				  	else       okflg = 1;
				  	ok_msg('K');
				  	break;	
				  	
/*				  					  	
				  case 'f': 
				  	k=123;l=3;
				  	xitoa((int)k,(uint8_t)l);
				  	
				  	k=12335;l=5;
				  	xitoa(k,l);
				  	break;
*/				  	
			  	  default:
//				    ng_msg(c);	
				  	break;
				  }
			  }
			  }  /*  swichi end */
		  }
}
	  	
unsigned char motdx( unsigned char mot,  unsigned char mkx) 
   /*  i mot  :  ㎥p^[@@@@	@		 */
   /*  i mkx  :  [^[ށ@QFto@PFao    */
   /*  o motd :  |[gf[^XV 	@@@		 */
{
	unsigned char outc, motp1;
	if( mkx == 1 ) {    /*  oC|[^Cv  */
		 outc = 0;
		 if( mot & 0x08 ){ outc = outc | 0x08 ;  }        		  /*chk 0000 *000 */
                                                                     /* 0000 1000 */
		 if( mot & 0x02 ){ outc = outc | 0x04 ;  }                /*chk 0000 00*0 */
                                                                     /* 0000 0100 */
		 if( mot & 0x04 ){ outc = outc | 0x02 ;  }                /*chk 0000 0*00 */
                                                                     /* 0000 0010 */
		 if( mot & 0x01 ){ outc = outc | 0x01 ;  }                /*chk 0000 000* */
                                                                     /* 0000 0001 */
	} else {
		outc=mot;
	}
	motp1 = outc;
	return( motp1 );
}

void pcstepm(){
	setres('-');
}
	  	
void stepm(){
	uchar rw, WC;	
	uchar flg_b;
	if(rseq <0 ) rseq=smax;
	if(rseq > smax) rseq=0;

	flg_b=0;
	if( cstep == 0){
		T2CONbits.TMR2ON=0;   //  ^C}[stop
		pcc1=0;
		wait = CMD_GO;        //  EXEC@GO
		if( move == MX ){
			ok_msg('X');
		} else {
			ok_msg('Y');
		}

        rw=0;    //free
	} else if(cstep==1){     //TA7257P@i؂ւɍŒł100uS Kvj
		spw=200;            //  2ms
		rw=0;	//  free
	    if ( MK == BP  &  brakes_f == 1 ) {  // oC|[  u[Lw
	    	rw=0xF0;
	    	flg_b=1;
			if( move == MX){
				PORTB = rw;
			} else {
				WC    = PORTC & 0x0F;
				PORTC = rw | WC;
			}	
	    }
	} else {
		if( accn>0 &  tstep>=accn<<1 ) {
			if( tstep ==  cstep-1 ) tp=0;                       //  idx 
				if( cstep+accn-2 >= tstep  ) { 
					spw = acce[tp++];
					if( move == MX ) spw += xf;
				}  //  ̃pX	
			if( cstep == accn ) tp=accn-1;                      //  idx 
            if(cstep<=accn){
            	spw=acce[tp--];
				if( move == MX ) spw += xf;
            }                    //  ̃pX
		}
		if( sou == 1 ) rw=pals1 [rseq]; // 1
		if( sou == 2 ) rw=pals2 [rseq]; // 2
		if( sou == 3 ) rw=pals12[rseq]; // 1-2
		
		if( move == MX )xkeep=rseq;
		else     		ykeep=rseq;
	}
	
	if( flg_b==0){   // u[LȊO
		if( move == MX){
			PORTB = motdx(rw,MK)<<4;   // x
		} else {
			WC    = PORTC & 0x0F;
			PORTC = motdx(rw,MK)<<4  | WC;   // y
		}	
	}
	
	if(dir) rseq++;  // Oi step
	else    rseq--;
	cstep--;         // total step 
	icnt=0;
}
	
	  	
void aptime(void){    // ^C}[荞݂̏
	uchar p;

	if(PIR1bits.TMR2IF == 1){
		PIR1bits.TMR2IF = 0 ;      // Xe[^X@tONA
		if(icnt==spw){
			stepm();               // [^[
		} else {
			icnt++;                // 荞݉񐔃JEg
		}	
	}

}

uint8_t cx(uint8_t d1){
		if(d1>9) { d1='7'+d1;}
	        else { d1='0'+d1;}
	return d1;
}
void   hex1( uint8_t d ){
	     setres(cx(d>>4));
	     setres(cx(d & 0x0f));
}
void   hex2( uint16_t d ){
	    setres(cx((uint8_t)(d>>12        )));
	    setres(cx((uint8_t)(d>>8 & 0x000f)));
	    setres(cx((uint8_t)(d>>4 & 0x000f)));
	    setres(cx((uint8_t)(d    & 0x000f)));	
}

